<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-03-20 14:36:37
 * @LastEditors: 无尘
 * @LastEditTime: 2019-11-08 03:54:57
 -->
<!--
  <taskView :brandId="brandId" activeGroupId></taskView>
  import taskView from '@/components/app/taskView.vue';
 -->
<template>
  <div>
    <div class="daily-set-content boder-box">
      <div class="table-condition flex flex-space-between m-b-20">
        <div class="table-condition-left">
          <el-input placeholder="请输入话务任务名称" v-model="conditionObj.searchInput" class="w-264" style="width: 264px;" @keyup.native="value => toInput(value, conditionObj.searchInput)"> <i slot="prefix" class="el-input__icon el-icon-search"></i> </el-input>
          <span class="condition-tips font-12 color-909399 p-l-10">仅包含话务任务记录</span>
        </div>
        <div class="table-condition-right">
          <el-button type="danger" @click="multDel">批量删除</el-button>
          <!-- <el-button type="primary" @click="exportExcel"><i class="iconfont icon-icon_yunxiazai p-r-6"></i>导出</el-button> -->
        </div>
      </div>
      <!--<div class="view-classify m-b-20">
        <el-radio-group v-model="conditionObj.tableType" @change="changeTable">
          <el-radio-button label="1" name="门店视图">门店视图</el-radio-button>
          <el-radio-button label="2" name="话务任务视图">话务任务视图</el-radio-button>
        </el-radio-group>
      </div>-->
      <el-table class="select-table" ref="multipleTable" :data="tableData" tooltip-effect="dark" :style="{ width: '100%', minHeight: tableH }" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="35"> </el-table-column>
        <el-table-column width="25">
          <template slot="header" slot-scope="scope">
            <el-dropdown style="line-height: 10px; padding: 0; margin-left: -15px; transform: translateY(4px); -webkit-transform: translateY(4px);" @command="handleCommand" placement="bottom-start">
              <span class="el-dropdown-link"><i class="el-icon-arrow-down el-icon--right"></i> </span>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="0"><span :style="{ color: selectRadio == 0 ? '#1890ff' : '#606266' }">选择当页</span></el-dropdown-item>
                <el-dropdown-item command="1"><span :style="{ color: selectRadio == 1 ? '#1890ff' : '#606266' }">选择全部</span></el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
          <template slot-scope="scope"> </template>
        </el-table-column>
        <el-table-column label="任务名称" width="120" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.ecmName }}</template>
        </el-table-column>
        <el-table-column prop="" label="已完成" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.competedTaskNum }}</template>
        </el-table-column>
        <el-table-column prop="" label="完成率" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.competedTaskRate }}</template>
        </el-table-column>
        <el-table-column prop="" label="待完成" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.toComplete }}</template>
        </el-table-column>
        <el-table-column prop="" label="逾期中" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.overTimeNum }}</template>
        </el-table-column>
        <el-table-column label="操作">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click="toDetail(scope.$index, scope.row)">查看详情</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block common-wrap__page text-right m-t-24" v-if="tableData.length != 0">
        <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>
      </div>
    </div>
    <multiple-del :showDialog="showDialog" :detailFlag="false" @hideDialog="hideDialog"> </multiple-del>
  </div>
</template>
<script>
// import navCrumb from '@/components/nav/nav.vue';
import appDetail from '@/components/app/app-detail.vue';
import vueSelectStore from 'components/common/vueSelectStore';
import commonDetailTop from '@/components/app/common-detail-top.vue';
import multipleDel from '@/components/app/cloudDaily/multiple-del.vue';
import { getRequest, postRequest, postExcel } from '@/api/api';
import { _debounce } from '@/common/js/public';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
export default {
  name: 'taskView',
  props: {
    brandId: {
      type: String,
      default() {
        return '';
      }
    },
    activeGroupId: {
      type: String,
      default() {
        return '';
      }
    }
  },
  data() {
    return {
      tableH: window.screen.availHeight - 464 - 126,
      activeTab: '1',
      activeBrand: this.brandId, // 商户(品牌) id
      activeGroup: this.activeGroupId, // 商户(品牌) groupId
      topMenuData: [
        {
          id: '1',
          name: '话务任务记录'
        }
      ],
      activeId: '1',
      showDialog: false,
      // 条件
      conditionObj: {
        tableType: '1',
        searchInput: '',
        storeGroup: [],
        storeType: '',
        dateRange: []
      },
      storeTypeOptions: [
        {
          value: '',
          label: '所有'
        },
        {
          value: '0',
          label: '自营'
        },
        {
          value: '1',
          label: '联营'
        },
        {
          value: '2',
          label: '代理'
        },
        {
          value: '3',
          label: '代销'
        },
        {
          value: '4',
          label: '托管'
        }
      ],
      selectRadio: 0, // 选择当页/选择全部
      tableData: [],
      multipleSelection: [],
      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0,

      // 门店选择
      appScene: 2,
      defaultStoreList: [],
      storeTreeSet: {
        isSelectPerson: false, // 控制只能选部门(false)
        dialogVisible: false, // 控制显示/隐藏
        isSingle: false // 是否单选
      }
    };
  },
  computed: {},
  methods: {
    /**
     * 改变视图
     */
    changeTable(e) {
      const that = this;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 显示选择本页/全部
     */
    handleCommand(command) {
      this.selectRadio = command;
    },
    /**
     * 返回 的 brandId
     */
    setSelectTab(item) {
      let that = this;
      that.activeTab = item.tabId;
    },

    /**
     * 输入
     */
    toInput: _debounce(function(e, value) {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    }, 500),

    /**
     * 门店类型
     */
    changeStoreType() {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 日期
     */
    changeDate(e) {
      let that = this;
      if (!e) {
        that.conditionObj.dateRange = [];
      }
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 表格选择
     */
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

    /**
     * 删除选的部门
     */
    delDepart(index, item) {
      let that = this;
      item.splice(index, 1);
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 批量删除
     */
    multDel() {
      let that = this;
      if (!that.multipleSelection.length) {
        that.$message.error({
          duration: 1000,
          message: '请选择删除项'
        });
        return false;
      }
      that.showDialog = true;
    },

    /**
     * 批量删除---弹窗关闭
     */
    hideDialog(obj) {
      let that = this;
      that.showDialog = false;
      if (!Object.keys(obj).length) {
        return false;
      }
      that.postMultDel(obj);
    },

    postMultDel(obj) {
      const that = this;
      if (!that.conditionObj.dateRange) {
        that.conditionObj.dateRange = [];
      }
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        ecmIds: that.multipleSelection.map(ele => ele.ecmIds).join(',') || '', // 门店分组,数组
        brandId: that.activeBrand, // 品牌 id
        delTaskStatus: obj.delOptFlag, // 0:仅删除逾期任务，1:删除所有待完成任务
        reason: obj.reason, // 备注
        isAll: that.selectRadio // 0：当页，1：所有
        // taskType: 1 //0不良评价，1话务任务
      };
      postRequest('/haoban-app-tel-task-web/task/batch-del-task-view-list', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('删除成功', 'success');
            that.getTableList();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * 导出
     */
    exportExcel() {
      let that = this;
      let storeGroups = [];
      let filterStoreIds = [];
      that.conditionObj.storeGroup.forEach(ele => {
        if (ele.type == 2) {
          storeGroups.push(ele.groupId);
        }
        if (ele.type == 3) {
          filterStoreIds.push(ele.storeId);
        }
      });
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        filterStoreIds: filterStoreIds.join(',') || '', // 门店分组, 门店
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,数组
        // storeIds: that.multipleSelection.map(ele => ele.storeId).join(',') || '', // 门店分组,数组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: !!that.conditionObj.dateRange ? that.conditionObj.dateRange[0] : '',
        endDate: !!that.conditionObj.dateRange ? that.conditionObj.dateRange[1] : '',
        brandId: that.activeBrand // 品牌 id
        // taskType: 1 //0不良评价，1话务任务
      };
      /* let urlSource = `search=${para.search}&filterStoreIds=${para.filterStoreIds}&storeGroupIds=${para.storeGroupIds}&storeType=${para.storeType}&startDate=${para.startDate}&endDate=${para.endDate}&brandId=${para.brandId}`;
      window.open(`${window.location.origin}/haoban-app-tel-task-web/task/export-store-task-list?${urlSource}`); */
      postExcel('/haoban-app-tel-task-web/task/export-store-task-list', para)
        .then(res => {
          if (!res.data) {
            errMsg.errorMsg('暂无数据');
            return false;
          }
          // let resData = res.data;
          const blob = new Blob([res.data], { type: 'application/vnd.ms-excel' });
          const fileName = `${that.tableData[0] ? that.tableData[0].storeName : ''}门店任务报表.csv`;
          const elink = document.createElement('a');
          elink.download = fileName;
          elink.style.display = 'none';
          elink.href = URL.createObjectURL(blob);
          document.body.appendChild(elink);
          elink.click();
          URL.revokeObjectURL(elink.href); // 释放URL 对象
          document.body.removeChild(elink);
          // errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * 分页---页码变化
     */
    handleSizeChange(val) {
      const that = this;
      that.pageSize = val;
      that.getTableList();
    },

    /**
     * 分页---当前页变化
     */
    handleCurrentChange(val) {
      const that = this;
      that.currentPage = val;
      // let fullPath = that.$route.fullPath;
      that.getTableList();
    },

    /**
     * 弹窗显示事件
     */
    showDialogLayer(type, selData) {
      const that = this;
      that.selectType = type;
      that.changed = type;
      that.defaultStoreList = selData;
      that.storeTreeSet = {
        dialogVisible: true,
        isSingle: false,
        isSelectPerson: false
      };
    },

    /**
     * 处理已选部门
     */
    handleSelectedList(group) {
      let that = this;
      // type:	1:员工,2:部门,3:门店;
      that.conditionObj.storeGroup = group;
      that.getTableList();
    },

    /**
     * 查看详情
     */
    toDetail(index, row) {
      let that = this;
      that.$router.push(`taskViewDetail?ecmId=${row.ecmId}&appIcon=${that.$route.query.appIcon}`);
    },

    /**
     * 获取列表数据
     */
    getTableList(val) {
      let that = this;

      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        pageNum: that.currentPage, // 当前页
        pageSize: that.pageSize, // 一页显示个数
        brandId: that.activeBrand
        // taskType: 1 //0不良评价，1话务任务
      };
      getRequest('/haoban-app-tel-task-web/task/task-view-list', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            that.tableData = resData.result.list || [];
            that.total = resData.result.pageInfo.total;
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    initDataRange() {
      let date = new Date();
      let nowTime = date.getTime() - 90 * 24 * 3600 * 1000;
      let year = date.getFullYear();
      let month = date.getMonth() + 1;
      let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
      let newMonth = month < 10 ? '0' + month : month;

      let startDate = new Date(nowTime);
      let startYear = startDate.getFullYear();
      let startMonth = startDate.getMonth() + 1;
      let startDay = startDate.getDate() < 10 ? '0' + startDate.getDate() : startDate.getDate();
      let startNewMonth = startMonth < 10 ? '0' + startMonth : startMonth;
      return [`${startYear}-${startNewMonth}-${startDay}`, `${year}-${newMonth}-${day}`];
    }
  },
  watch: {
    brandId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeBrand = newData;
        that.getTableList();
      }
    },
    activeGroupId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeGroup = newData;
      }
    }
  },
  mounted() {
    const that = this;
    that.conditionObj.dateRange = that.initDataRange();
    document.documentElement.style.backgroundColor = '#f0f2f5';
    that.activeBrand = that.brandId;
    if (!!this.brandId) {
      that.$nextTick(() => {
        that.getTableList();
      });
    }
  },
  destroyed() {
    document.documentElement.style.backgroundColor = '#fff';
  },
  components: {
    appDetail,
    commonDetailTop,
    vueSelectStore,
    multipleDel
  }
};
</script>
<style type="text/scss" lang="scss" scoped>
.color-c0c4cc {
  display: inline-block;
  line-height: 34px;
  padding-left: 10px;
  color: #c0c4cc;
}
.condition-tips {
  display: inline-block;
  vertical-align: middle;
  line-height: 32px;
}
.table-condition {
  min-width: 1200px;
}
.daily-set-wrap {
  height: 100%;
  .daily-set-content {
    padding: 20px;
    .table-condition-left {
      font-size: 0;
    }
  }

  .depart-item-content {
    width: 213px;
    height: 32px;
    overflow: hidden;
    white-space: nowrap;
    border-radius: 4px;
    border: 1px solid #dcdfe6;
    cursor: pointer;
  }

  .item-cell-select {
    /deep/ .el-select__tags {
      white-space: nowrap;
      overflow: hidden;
    }
  }

  .depart-cell {
    position: relative;
    margin: 0 24px 24px 0;

    .el-icon-circle-close {
      position: absolute;
      top: -10px;
      right: -10px;
      font-size: 16px;
      color: #808995;
      cursor: pointer;
    }
  }
}
</style>
